---
title: llarp::layers::platform::FlowTraffic_IO

---

# llarp::layers::platform::FlowTraffic_IO





## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowTraffic_IO](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-flowtraffic-io)**([FlowTraffic_IO_pimpl](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO__pimpl.md) * ) |
| void | **[write_many_to_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-write-many-to-flow-layer)**(EtherType_t kind, [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) to, std::vector< std::vector< byte_t >> datums)<br>send many dataums of the same kind to a flow on the flow layer.  |
| void | **[write_to_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-write-to-flow-layer)**(EtherType_t kind, [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) to, std::vector< byte_t > data)<br>helper to write one datum to the flow layer  |
| std::vector< [flow::Traffic](Classes/structllarp_1_1layers_1_1flow_1_1Traffic.md) > | **[read_from_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-read-from-flow-layer)**()<br>does a full read and drains everything from flow layer and returns what was read if anything was.  |
| void | **[wakeup](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-wakeup)**() const<br>wake up the flow layer telling it we sent it something, idempotently.  |

## Public Functions Documentation

### function FlowTraffic_IO

```cpp
FlowTraffic_IO(
    FlowTraffic_IO_pimpl * 
)
```


### function write_many_to_flow_layer

```cpp
void write_many_to_flow_layer(
    EtherType_t kind,
    flow::FlowInfo to,
    std::vector< std::vector< byte_t >> datums
)
```

send many dataums of the same kind to a flow on the flow layer. 

this call MUST wake up the flow layer idempotently. 


### function write_to_flow_layer

```cpp
inline void write_to_flow_layer(
    EtherType_t kind,
    flow::FlowInfo to,
    std::vector< byte_t > data
)
```

helper to write one datum to the flow layer 

### function read_from_flow_layer

```cpp
std::vector< flow::Traffic > read_from_flow_layer()
```

does a full read and drains everything from flow layer and returns what was read if anything was. 

### function wakeup

```cpp
void wakeup() const
```

wake up the flow layer telling it we sent it something, idempotently. 

-------------------------------

Updated on 2023-02-01 at 02:20:07 +0000