---
title: llarp::layers::platform::NameResolverJob_Base
summary: a one shot job that will resolve a string to a resolved name to a platform address. 

---

# llarp::layers::platform::NameResolverJob_Base



a one shot job that will resolve a string to a resolved name to a platform address. 


`#include <name_resolver.hpp>`

Inherited by [llarp::layers::platform::NameLookupJob_Deprecated](Classes/classllarp_1_1layers_1_1platform_1_1NameLookupJob__Deprecated.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[NameResolverJob_Base](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#function-nameresolverjob-base)**(std::string_view name_, std::chrono::duration< double > timeout_) |
| virtual void | **[resolve_icann_addr_async](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#function-resolve-icann-addr-async)**(std::function< void(std::vector< [dns::ResourceRecord](Classes/structllarp_1_1dns_1_1ResourceRecord.md) >)> )<br>resolving via upstream resolver  |
| virtual void | **[resolve_flow_addr_async](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#function-resolve-flow-addr-async)**(std::function< void(std::optional< [flow::FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) >)> )<br>resolve using in network resolution  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| const TimePoint_t | **[started_at](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#variable-started-at)**  |
| const std::string | **[name](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#variable-name)**  |
| const std::chrono::duration< double > | **[timeout](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md#variable-timeout)**  |

## Public Functions Documentation

### function NameResolverJob_Base

```cpp
inline NameResolverJob_Base(
    std::string_view name_,
    std::chrono::duration< double > timeout_
)
```


### function resolve_icann_addr_async

```cpp
inline virtual void resolve_icann_addr_async(
    std::function< void(std::vector< dns::ResourceRecord >)> 
)
```

resolving via upstream resolver 

### function resolve_flow_addr_async

```cpp
inline virtual void resolve_flow_addr_async(
    std::function< void(std::optional< flow::FlowAddr >)> 
)
```

resolve using in network resolution 

**Reimplemented by**: [llarp::layers::platform::NameLookupJob_Deprecated::resolve_flow_addr_async](Classes/classllarp_1_1layers_1_1platform_1_1NameLookupJob__Deprecated.md#function-resolve-flow-addr-async)


## Protected Attributes Documentation

### variable started_at

```cpp
const TimePoint_t started_at {TimePoint_t::clock::now()};
```


### variable name

```cpp
const std::string name;
```


### variable timeout

```cpp
const std::chrono::duration< double > timeout;
```


-------------------------------

Updated on 2023-02-01 at 02:20:07 +0000