---
title: llarp::layers::platform::PlatformDriver_pimpl

---

# llarp::layers::platform::PlatformDriver_pimpl





## Public Functions

|                | Name           |
| -------------- | -------------- |
| [flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) & | **[flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-flow-layer)**() |
| std::shared_ptr< [NameResolverJob_Base](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md) > | **[make_resolver_job_for](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-make-resolver-job-for)**(UnresolvedName_t name) |
| bool | **[put_exit_up](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-put-exit-up)**()<br>put up the exit fire wall rules.  |
| void | **[put_exit_down](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-put-exit-down)**()<br>put exit firewall rules down.  |
| void | **[wakeup_os](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-wakeup-os)**()<br>wake up os parts of the event loop. tells the event loop to do another iteration.  |
| void | **[wakeup_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-wakeup-flow-layer)**()<br>wake up the flow layer. tells it we have sent it tasks to complete.  |
| void | **[before_loop_ready](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-before-loop-ready)**()<br>calls anything we need to do before polling for io, unconditionally.  |
| bool | **[loop_ready](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-loop-ready)**()<br>calls anything we need to do after polling for io when we got things from io.  |
| void | **[after_loop_ready](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-after-loop-ready)**()<br>handles completions of tasks created by [loop_ready()](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-loop-ready) |
| | **[PlatformDriver_pimpl](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-platformdriver-pimpl)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & router_, [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) conf) |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & | **[router](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#variable-router)**  |
| [AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md) | **[addr_mapper](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#variable-addr-mapper)**  |

## Public Functions Documentation

### function flow_layer

```cpp
inline flow::FlowLayer & flow_layer()
```


### function make_resolver_job_for

```cpp
inline std::shared_ptr< NameResolverJob_Base > make_resolver_job_for(
    UnresolvedName_t name
)
```


### function put_exit_up

```cpp
inline bool put_exit_up()
```

put up the exit fire wall rules. 

return true if we put them up successfully. 


### function put_exit_down

```cpp
inline void put_exit_down()
```

put exit firewall rules down. 

### function wakeup_os

```cpp
inline void wakeup_os()
```

wake up os parts of the event loop. tells the event loop to do another iteration. 

### function wakeup_flow_layer

```cpp
inline void wakeup_flow_layer()
```

wake up the flow layer. tells it we have sent it tasks to complete. 

### function before_loop_ready

```cpp
inline void before_loop_ready()
```

calls anything we need to do before polling for io, unconditionally. 

this call MUST NOT wake up the event loop. 


### function loop_ready

```cpp
inline bool loop_ready()
```

calls anything we need to do after polling for io when we got things from io. 

returns true if we do things that need to be completed by calling [after_loop_ready()](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-after-loop-ready). 


### function after_loop_ready

```cpp
inline void after_loop_ready()
```

handles completions of tasks created by [loop_ready()](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-loop-ready)

### function PlatformDriver_pimpl

```cpp
inline PlatformDriver_pimpl(
    AbstractRouter & router_,
    NetworkConfig conf
)
```


## Public Attributes Documentation

### variable router

```cpp
AbstractRouter & router;
```


### variable addr_mapper

```cpp
AddrMapper addr_mapper;
```


-------------------------------

Updated on 2023-02-01 at 02:20:07 +0000