---
title: llarp::layers::platform::PlatformAddr
summary: a (ipv6 address, flowlabel) tuple that we use for platform layer side addressing 

---

# llarp::layers::platform::PlatformAddr



a (ipv6 address, flowlabel) tuple that we use for platform layer side addressing 


`#include <platform_addr.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#function-platformaddr)**() =default |
| | **[PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#function-platformaddr)**([huint128_t](Classes/structllarp_1_1huint__t.md) addr) |
| std::string | **[ToString](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#function-tostring)**() const<br>string representation  |
| net::ipv4addr_t | **[as_v4](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#function-as-v4)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| net::ipv6addr_t | **[ip](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#variable-ip)** <br>ip network address  |
| net::flowlabel_t | **[flowlabel](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md#variable-flowlabel)** <br>flowlabel, ingored if ip is a v4 mapped address this is used as a metric to do flow layer isolation where we can use different identities and / or paths on each.  |

## Public Functions Documentation

### function PlatformAddr

```cpp
PlatformAddr() =default
```


### function PlatformAddr

```cpp
PlatformAddr(
    huint128_t addr
)
```


### function ToString

```cpp
std::string ToString() const
```

string representation 

### function as_v4

```cpp
net::ipv4addr_t as_v4() const
```


## Public Attributes Documentation

### variable ip

```cpp
net::ipv6addr_t ip {};
```

ip network address 

### variable flowlabel

```cpp
net::flowlabel_t flowlabel {};
```

flowlabel, ingored if ip is a v4 mapped address this is used as a metric to do flow layer isolation where we can use different identities and / or paths on each. 

defaults to zero. 


-------------------------------

Updated on 2023-02-01 at 02:20:07 +0000