---
title: llarp/layers/flow/flow_identity.hpp

---

# llarp/layers/flow/flow_identity.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::flow::FlowIdentityPrivateKeys](Classes/structllarp_1_1layers_1_1flow_1_1FlowIdentityPrivateKeys.md)**  |
| class | **[llarp::layers::flow::FlowIdentity](Classes/classllarp_1_1layers_1_1flow_1_1FlowIdentity.md)** <br>the local end of a one to one flow to a remote.  |




## Source code

```cpp
#pragma once

#include <llarp/crypto/types.hpp>

#include "flow_addr.hpp"
#include "flow_auth.hpp"
#include "flow_info.hpp"
#include "flow_state.hpp"

namespace llarp::layers::flow
{

  struct FlowIdentityPrivateKeys
  {
    SecretKey identity;
    SecretKey encryption;
    PrivateKey derivedKey;
    PQKeyPair sntrup;

    static FlowIdentityPrivateKeys
    keygen();
  };

  class FlowIdentity
  {
    const FlowIdentityPrivateKeys& _local_privkeys;
    const FlowInfo _remote;
    FlowState _state;

   public:
    void
    async_ensure_flow(FlowHandshaker handshaker);
  };
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-01 at 02:20:08 +0000
