---
title: llarp/layers/platform/name_resolver.hpp

---

# llarp/layers/platform/name_resolver.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::NameResolverJob_Base](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md)** <br>a one shot job that will resolve a string to a resolved name to a platform address.  |




## Source code

```cpp
#pragma once

#include "llarp/dns/rr.hpp"
#include "llarp/layers/flow/flow_addr.hpp"
#include "platform_addr.hpp"

#include <chrono>
#include <functional>
#include <optional>

#include <oxenc/variant.h>

#include <llarp/util/types.hpp>
#include <llarp/dns/question.hpp>
#include <variant>
#include <vector>

namespace llarp::layers::platform
{

  using UnresolvedName_t = std::variant<std::string_view, dns::Question>;

  class NameResolverJob_Base
  {
   protected:
    const TimePoint_t started_at{TimePoint_t::clock::now()};
    const std::string name;
    const std::chrono::duration<double> timeout;

   public:
    NameResolverJob_Base(std::string_view name_, std::chrono::duration<double> timeout_)
        : name{name_}, timeout{timeout_} {};

    virtual void resolve_icann_addr_async(std::function<void(std::vector<dns::ResourceRecord>)>){};

    virtual void resolve_flow_addr_async(std::function<void(std::optional<flow::FlowAddr>)>){};
  };

}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-02-01 at 02:20:08 +0000
